/*
* LumaQQ - Java QQ Client
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.demo;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import edu.tsinghua.swt.widgets.BottomHide;
import edu.tsinghua.swt.widgets.BottomShow;
import edu.tsinghua.swt.widgets.Hinter;
import edu.tsinghua.swt.widgets.Spin;

/**
 * <pre>
 * </pre>
 * 
 * @author 
 */
public class HinterTest {
    public Hinter hh;
    public static void main(String[] args) {
		Display display = new Display();
        HinterTest demo = new HinterTest();
		Shell shell = demo.open(display);
		while(!shell.isDisposed()) 
		{
			if(!display.readAndDispatch()) 
				display.sleep();
		}
		display.dispose();
    }
	private Shell open(Display display) {
		Shell shell = new Shell();
		shell.setText("test");
		shell.setLayout(new FormLayout());
		final Composite comp = new Composite(shell, SWT.BORDER);
		FormData fd = new FormData();
		fd.top = fd.left = new FormAttachment(0, 50);
		fd.bottom = new FormAttachment(60, 0);
		fd.right = new FormAttachment(50, 0);
		comp.setLayoutData(fd);
		comp.setLayout(new GridLayout());
		
		Spin spin = new Spin(comp, SWT.TOP);
		GridData gd = new GridData();
		gd.widthHint = 100;
		gd.heightHint = 100;
		spin.setLayoutData(gd);
		spin.setMax(10);
		spin.setMin(4);
		
		spin = new Spin(comp, SWT.BOTTOM);
		gd = new GridData();
		gd.widthHint = 100;
		gd.heightHint = 100;
		spin.setLayoutData(gd);
		shell.addMouseListener(new MouseAdapter() {
		    /* (non-Javadoc)
             * @see org.eclipse.swt.events.MouseAdapter#mouseDown(org.eclipse.swt.events.MouseEvent)
             */
            public void mouseDown(MouseEvent e) {
                Hinter h = new Hinter((Shell)e.getSource(), 180, 100);
                hh = h;
                h.setShowStyle(new BottomShow());
                h.setHideStyle(new BottomHide());
                h.show();
            }
            
            /* (non-Javadoc)
             * @see org.eclipse.swt.events.MouseAdapter#mouseUp(org.eclipse.swt.events.MouseEvent)
             */
            public void mouseUp(MouseEvent e) {
                hh.hide();
            }
		});
		shell.open();		
		return shell;
	}
}
