/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.demo;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Control;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.Shell;

import edu.tsinghua.swt.internal.resources.Icons;
import edu.tsinghua.swt.models.DefaultShutterModel;
import edu.tsinghua.swt.models.ScrollListItem;
import edu.tsinghua.swt.models.ShutterTab;
import edu.tsinghua.swt.widgets.MySWT;
import edu.tsinghua.swt.widgets.Shutter;
import edu.tsinghua.swt.widgets.CoolButton;

/**
 * @author luma@smth
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class ShutterDemo {
	private static int item = 0;
	private static int tab = 0;
	private static Icons icons;
	public static void main(String[] args) {
		// just for demo purpose, not directly use Icons in your program
		icons = Icons.getInstance();
		
		Display display = new Display();
		ShutterDemo demo = new ShutterDemo();
		Shell shell = demo.open(display);
		while(!shell.isDisposed()) 
		{
			if(!display.readAndDispatch()) 
				display.sleep();
		}
		display.dispose();
	}	
	
	private Shell open(Display display)
	{
		Shell shell = new Shell();
		shell.setText("Shutter Demo");
		shell.setSize(700, 500);
		
		shell.setLayout(new FormLayout());
		final Shutter shutter = new Shutter(shell, SWT.BORDER);
		FormData fd = new FormData();
		fd.top = new FormAttachment(0, 0);
		fd.bottom = new FormAttachment(100, 0);
		fd.left = new FormAttachment(0, 0);
		fd.right = new FormAttachment(33, 0);
		shutter.setLayoutData(fd);
		final DefaultShutterModel model = new DefaultShutterModel();
		model.addTab("Ʒ");
		model.addTab("Written by luma@smth", null);
		model.addTab("ӭʹ");
		final ScrollListItem slItem = new ScrollListItem("Shutterؼ 0.3 Beta4");
		model.addItem(0, slItem);
		model.addItem(0, "SWT");
		model.addItem(0, "ӭ");
		model.addItem(0, "Bug֪ͨ");
		model.addItem(1, "Ǻ");
		model.addItem(2, "Shutter: Ҷ");
		model.addItem(2, "ûиõأ");
		model.addItem(2, "ֻ");
		shutter.setModel(model);
		
		Button button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(0, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ڵǰTabһItemΪڶItem");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					model.insertItem(shutter.getCurrentTab(), 1, "New Item " + item++);
				} 
			}
		);
		Control prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ڵǰTabһItem");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					model.addItem(shutter.getCurrentTab(), "New Item " + item++);
				} 
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ɾǰڵĵһItem");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					model.removeItem(shutter.getCurrentTab(), 0);
				} 
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("һTab");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					model.addTab("New Tab " + tab++, null);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ɾǰTab");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					model.removeTab(shutter.getCurrentTab());
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("һTabΪڶTab");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					model.insertTab(1, new ShutterTab("Inserted", null));
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("Tabƽ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.sortTabs(true);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ȡTab");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.unsortTabs();
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("Tabݽн");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.sortItems(false);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ȡǰList");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.unsortItems();
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("õǰΪ2");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setContentColumns(2, shutter.getCurrentTab());
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôʾͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setShowSmallImage(false);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôʾСͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setShowSmallImage(true);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôڸ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setContentAlignment(SWT.CENTER);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôڲʾı");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setShowText(false);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôʾı");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setShowText(true);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôıʾͼ·");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setTextOrientation(SWT.BOTTOM);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôıʾͼϷ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setTextOrientation(SWT.TOP);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôıʾͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setTextOrientation(SWT.LEFT);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(33, 0);
		fd.right = new FormAttachment(66, 0);
		button.setLayoutData(fd);
		button.setText("ôıʾͼҷ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setTextOrientation(SWT.RIGHT);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(0, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("õǰڵĵһItemTooltip");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setItemToolTipText("Hello, Shutter\nhaha", MySWT.ALL, MySWT.ALL);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ôڱΪɫ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.setContentBackground(Display.getCurrent().getSystemColor(SWT.COLOR_BLUE));
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ڵǰTab˸һͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.startBlinkImage(icons.getImage(MySWT.DEFAULT_IMAGE), shutter.getCurrentTab());
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ֹͣ˸ǰTabϵͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.stopBlinkImage(shutter.getCurrentTab());
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ڵǰTabһͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.startBounceImage(icons.getImage(MySWT.DEFAULT_IMAGE), shutter.getCurrentTab());
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ֹͣǰTabϵͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.stopBounceImage(shutter.getCurrentTab());
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ڵǰTabһItem˸һͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					CoolButton tab = shutter.getItemControl(shutter.getCurrentTab(), 0);
					if(tab != null)
						tab.startBlinkImage(icons.getImage(MySWT.DEFAULT_IMAGE));
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ֹͣ˸ǰTabһItem");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					CoolButton tab = shutter.getItemControl(shutter.getCurrentTab(), 0);
					if(tab != null)
						tab.stopBlinkImage();
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ڵǰTabĵһItemһͼ");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					CoolButton item = shutter.getItemControl(shutter.getCurrentTab(), 0);
					if(item != null)
						item.startBounceImage(icons.getImage(MySWT.DEFAULT_IMAGE));
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ֹͣǰTabһItem");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					CoolButton item = shutter.getItemControl(shutter.getCurrentTab(), 0);
					if(item != null) 
						item.stopBounceImage();
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ı䵱ǰTab");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.editTabName(shutter.getCurrentTab());
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("ı䵱ǰListĵһItem");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.editItemName(shutter.getCurrentTab(), 0);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("صǰTab");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.hideTab(shutter.getCurrentTab(), true);
				}
			}
		);
		prev = button;
		
		button = new Button(shell, SWT.PUSH);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		button.setLayoutData(fd);
		button.setText("صǰTabĵһItem");
		button.addSelectionListener(
			new SelectionAdapter() {
				public void widgetSelected(SelectionEvent e) {
					shutter.hideItem(shutter.getCurrentTab(), 0, true);
				}
			}
		);
		prev = button;
		
		Label label = new Label(shell, SWT.BORDER);
		fd = new FormData();
		fd.top = new FormAttachment(prev, 0);
		fd.left = new FormAttachment(66, 0);
		fd.right = new FormAttachment(100, 0);
		label.setLayoutData(fd);
		label.setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_RED));
		label.setText("TabItemĹ˹ûʾ");
		prev = label;
		
		shell.open();

		return shell;
	}
}
