/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.demo;

import java.io.FileInputStream;
import java.io.InputStream;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.graphics.PaletteData;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import edu.tsinghua.swt.widgets.MySWT;
import edu.tsinghua.swt.widgets.CoolButton;


/**
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 *
 * @author 
 */
public class ShutterLabelTest {
    
	public static void main(String[] args) {
		
		Display display = new Display();
		ShutterLabelTest demo = new ShutterLabelTest();
		Shell shell = demo.open(display);
		while(!shell.isDisposed()) 
		{
			if(!display.readAndDispatch()) 
				display.sleep();
		}
		display.dispose();
	}	
	
	private Shell open(final Display display)	{
		final Shell shell = new Shell();
		//shell.setText("Shutter Demo");
		shell.setSize(700, 500);
		shell.setLayout(new FormLayout());
		
		final Image image = createStockImage(display, "D:/eclipseM8/workspace/LumaQQ/src/newface/1-1.gif");
		final CoolButton canvas = new CoolButton(shell, MySWT.IMAGE_HOVER | MySWT.NO_ZOOM | SWT.CENTER, "ô׾͸ĺˣƵţ", null);
        PaletteData palette = new PaletteData(0xFF, 0xFF00 , 0xFF0000);
        ImageData id = image.getImageData();
        /*ImageData imageData = new ImageData(32, 32, 24, palette);
        for(int i = 0; i < 32; i++) {
        	for(int j = 0; j < 32; j++) {
        		RGB rgb = id.palette.getRGB(id.getPixel(i, j));
        		imageData.setPixel(i, j, rgb.red * 65535 + rgb.green * 255 + rgb.blue);
        	}
        }
        Image image2 = new Image(Display.getCurrent(), imageData);*/
        id.alpha = 2;
        Image image2 = new Image(display, id); 
        canvas.setImage(image2);
		final FormData fd = new FormData();
		fd.top = new FormAttachment(10, 0);
		fd.left = new FormAttachment(10, 0);
		canvas.setLayoutData(fd);
		canvas.setTextOrientation(SWT.BOTTOM);
		canvas.setShowSmallImage(false);		
		canvas.setMouseTrackColor(display.getSystemColor(SWT.COLOR_BLUE));

		shell.addMouseListener(new MouseListener(){

            public void mouseDoubleClick(MouseEvent arg0) {
               
            }

            public void mouseDown(MouseEvent arg0) {
            	canvas.setShowSmallImage(true);
            	fd.right = null;
            	fd.bottom = null;
            	canvas.setTextOrientation(SWT.RIGHT);
            	shell.layout();
            }

            public void mouseUp(MouseEvent arg0) {
                
            }});

		canvas.addMouseListener(new MouseListener(){

            public void mouseDoubleClick(MouseEvent arg0) {
                
            }

            public void mouseDown(MouseEvent arg0) {
                //canvas.setShowSmallImage(true);
                //canvas.setTextOrientation(SWT.BOTTOM);
                canvas.stopAnimate();
            }

            public void mouseUp(MouseEvent arg0) {
                
            }});
		shell.open();
		return shell;
	}
	
		private static Image createStockImage(Display display, String path) {
			try {
				InputStream stream = new FileInputStream(path);
				if (stream != null) {
					ImageData imageData = new ImageData(stream);
					if (imageData != null) {
						ImageData mask = imageData.getTransparencyMask();
						return new Image(display, imageData, mask);
					}
				}
			} catch (Exception e) {
			}
			return null;
		}
}
