/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.demo;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseListener;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

import edu.tsinghua.swt.layout.SortData;
import edu.tsinghua.swt.layout.SortLayout;

/**
 * @author 
 *
 * To change the template for this generated type comment go to
 * Window - Preferences - Java - Code Generation - Code and Comments
 */
public class SortLayoutTest {
	public static void main(String[] args) {
		Display display = new Display();
		SortLayoutTest demo = new SortLayoutTest();
		Shell shell = demo.open(display);
		while(!shell.isDisposed()) 
		{
			if(!display.readAndDispatch()) 
				display.sleep();
		}
		display.dispose();
	}	
	
	private Shell open(Display display) {
		Shell shell = new Shell();
		shell.setText("test");
		shell.setLayout(new FormLayout());
		final Composite comp = new Composite(shell, SWT.BORDER);
		FormData fd = new FormData();
		fd.top = fd.left = new FormAttachment(0, 0);
		fd.bottom = new FormAttachment(100, 0);
		fd.right = new FormAttachment(50, 0);
		comp.setLayoutData(fd);
		SortLayout sl = new SortLayout(3, true, false);
		sl.makeColumnsEqualWidth = true;
		sl.makeRowsEqualHeight = true;
		sl.verticalSpacing = sl.horizontalSpacing = 0;
		sl.marginHeight = sl.marginWidth = 0;
		comp.setLayout(sl);
		
		Button b = new Button(comp, SWT.PUSH);
		b.setText("B");
		SortData ld = new SortData(SortData.FILL_BOTH, b.getText());
		b.setLayoutData(ld);
		Button bb = b;
		
		b = new Button(comp, SWT.PUSH);
		b.setText("C");
		ld = new SortData(SortData.FILL_BOTH, b.getText());
		b.setLayoutData(ld);
		
		b = new Button(comp, SWT.PUSH);
		b.setText("A");
		ld = new SortData(SortData.FILL_BOTH, b.getText());
		b.setLayoutData(ld);
		
		b = new Button(comp, SWT.PUSH);
		b.setText("D");
		ld = new SortData(SortData.FILL_BOTH, b.getText());
		b.setLayoutData(ld);
		
		shell.addMouseListener(
			new MouseListener() {
				public void mouseDoubleClick(MouseEvent mouseevent) {					
				}

				public void mouseDown(MouseEvent mouseevent) {
					SortLayout sl = (SortLayout)comp.getLayout();
					sl.ascendent = true;
					comp.layout();
				}

				public void mouseUp(MouseEvent mouseevent) {					
				}				
			}
		);
		shell.open();		
		return shell;
	}
}
