/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.internal.events;

import java.util.List;

import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.widgets.Text;

import edu.tsinghua.swt.events.CoolButtonEvent;
import edu.tsinghua.swt.events.CoolButtonListener;
import edu.tsinghua.swt.widgets.CoolButton;

/**
 * If editor lost its focus, we also think the editing is end
 * 
 * @author 
 */
public class EditorFocusListener extends FocusAdapter {
	// CoolButton object
	private CoolButton ancestor;
	// shutter label event listeners
	private List listeners;
	
	/**
	 * constructor
	 * @param ancestor
	 * @param listeners
	 */
	public EditorFocusListener(CoolButton ancestor, List listeners) {
		this.ancestor = ancestor;
		this.listeners = listeners;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.FocusListener#focusLost(org.eclipse.swt.events.FocusEvent)
	 */
	public void focusLost(FocusEvent e) {
		// new a event object
		CoolButtonEvent event = new CoolButtonEvent(ancestor);
		event.oldText = ancestor.getText();
		if(event.oldText == null)
		    event.oldText = "";
		
		// set new text
		Text editor = (Text)e.getSource();
		ancestor.setText(editor.getText());
		editor.setVisible(false);
		
		// if text changed, fire event
		if(!event.oldText.equals(ancestor.getText())) {
			event.newText = ancestor.getText();
			int size = listeners.size();
			for(int i = 0; i < size; i++)
				((CoolButtonListener)listeners.get(i)).textChanged(event);
		}
	}
}
