/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.internal.events;

import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import edu.tsinghua.swt.widgets.Shutter;
import edu.tsinghua.swt.widgets.CoolButton;

/**
 * TabʱǵȱʡǰѵTabΪǰTab
 * 
 * @author 
 */
public class TabMouseListener extends MouseAdapter {
	// Shutter object
	private Shutter ancestor;
	
	/**
	 * constructor
	 * @param ancestor
	 */
	public TabMouseListener(Shutter ancestor) {
		this.ancestor = ancestor;
	}
	
	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.MouseListener#mouseUp(org.eclipse.swt.events.MouseEvent)
	 */
	public void mouseUp(MouseEvent e) {
		// get tab object
		CoolButton tab = (CoolButton)e.getSource();
		// if is left button, switch
		if(e.button==1) {
			// get tab index, set current tab
			int tabIndex = ancestor.indexOf(tab);
			ancestor.setCurrentTab(tabIndex);
			ancestor.getScrollList(tabIndex).forceFocus();
		}
	}

}
