/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.internal.layout;

import java.io.UnsupportedEncodingException;
import java.util.Comparator;


/**
 * Do the default compare -- compare the key's toString()
 *
 * @author 
 */
public class DefaultKeyComparator implements Comparator {
    /* (non-Javadoc)
     * @see java.util.Comparator#compare(java.lang.Object, java.lang.Object)
     */
    public int compare(Object o1, Object o2) {
        String _s1 = o1.toString();
        String _s2 = o2.toString();
        String s1, s2;
        try {
            // for Chinese
            s1 = new String(_s1.getBytes("GBK"), "ISO-8859-1");
            s2 = new String(_s2.getBytes("GBK"), "ISO-8859-1");
        } catch (UnsupportedEncodingException e) {
            s1 = _s1;
            s2 = _s2;
        }
        
        return s1.compareTo(s2);
    }
}
