/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.internal.resources;

import java.io.InputStream;

import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.ImageData;
import org.eclipse.swt.widgets.Display;

/**
 * <pre>
 * һڲ࣬ûӦʹࡣ
 * ฺȱʡԴһڵloadResources󣬱˳ʱfreeResources
 * </pre> 
 * 
 * @author 
 */
public class Icons {
	// image path array
	public static final String[] stockImageLocations = {
		"/icons/defaultImage.gif"
	};
	
	// store default images
	public Image stockImages[];
	
	// ü
	public static int reference; 

	// single instance
	private static Icons instance = new Icons();
	
	// private constructor
	private Icons() {
		reference = 0;
	}
	
	/**
	 * @return single instance
	 */
	public static Icons getInstance() {
		return instance;
	}
	
	/**
	 * return an image
	 * @param id
	 * @return
	 */
	public Image getImage(int id) {
		if(id < 0 || id >= stockImages.length) return null;
		else return stockImages[id];
	}

	/**
	 * Դ
	 * 
	 * @param display
	 *            the display
	 */
	public void loadResources() {
		// every time this method is called, count is increased
		reference++;
		// load icons only if stockImages is null
		if (stockImages == null) {
			Display display = Display.getCurrent();
			stockImages = new Image[stockImageLocations.length];
			for (int i = 0; i < stockImageLocations.length; i++) {
				Image image = createStockImage(display, stockImageLocations[i]);
				stockImages[i] = image;
			}
		}
	}

	/**
	 * ͷԴ
	 */
	public void freeResources() {
		// every time this method is called, decrease it
		reference--;
		// when stockImages isn't null and the number of control is 0, release icons
		if (stockImages != null && reference == 0) {
			for (int i = 0; i < stockImages.length; i++) {
				final Image image = stockImages[i];
				if (image != null)
					image.dispose();
			}
			stockImages = null;
		}
	}

	/**
	 * @param display
	 *            the display
	 * @param path
	 *            the relative path to the icon
	 * 
	 * ļImage
	 */
	private Image createStockImage(Display display, String path) {
		try {
			InputStream stream = Icons.class.getResourceAsStream(path);
			if (stream != null) {
				ImageData imageData = new ImageData(stream);
				if (imageData != null) {
					ImageData mask = imageData.getTransparencyMask();
					return new Image(display, imageData, mask);
				}
			}
		} catch (Exception e) {
		}
		return null;
	}
}
