/*
* LumaQQ - Java QQ Client
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;

/**
 * <pre>
 * ʾϢڣMSNϢʾһ𣬱ִ֧ӲͬЧ
 * 
 * ʾй̶ĴСҪԤṩĿؼѾʾϢʵ
 * </pre>
 * 
 * @author 
 */
public abstract class AbstractHinter {    
    /**
     * <pre>
     * ڵƶ¼
     * </pre>
     * 
     * @author 
     */
    private class ShellMouseMoveListener implements MouseMoveListener {
        /* (non-Javadoc)
         * @see org.eclipse.swt.events.MouseMoveListener#mouseMove(org.eclipse.swt.events.MouseEvent)
         */
		public void mouseMove(MouseEvent e) {
			if (isMove) {
				Point loc = hintShell.getLocation();
				int x = loc.x + e.x - downX;
				int y = loc.y + e.y - downY;
				hintShell.setLocation(x, y);
			}
		}
    }
    
    /**
     * <pre>
     * ڵ¼
     * </pre>
     * 
     * @author 
     */
    private class ShellMouseListener extends MouseAdapter {
		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.MouseListener#mouseDown(org.eclipse.swt.events.MouseEvent)
		 */
		public void mouseDown(MouseEvent e) {
			downX = e.x;
			downY = e.y;
			isMove = true;
		}
		
		/* (non-Javadoc)
		 * @see org.eclipse.swt.events.MouseListener#mouseUp(org.eclipse.swt.events.MouseEvent)
		 */
		public void mouseUp(MouseEvent e) {
			isMove = false;
		}
    }
    
    /**
     * <pre>
     * ʾڵػ¼ͼ
     * </pre>
     * 
     * @author 
     */
    private class ShellPainterListener implements PaintListener {
        /* (non-Javadoc)
         * @see org.eclipse.swt.events.PaintListener#paintControl(org.eclipse.swt.events.PaintEvent)
         */
        public void paintControl(PaintEvent e) {
            if(backgroundImage != null)
                e.gc.drawImage(backgroundImage, 0, 0);
        }
    }
    
    // ʾ
    protected Shell hintShell;
    // 
    protected Shell parent;
    // display
    protected Display display;
    // ͼ
    protected Image backgroundImage;
    // ʾڴС
    protected final int width, height;
    // ʾʽطʽ
    protected IShow showGril;
    protected IHide hideBoy;
    // ʾɺtop-leftӦʲôλ
    protected int initX, initY;
    // Ĳ
    protected int stepX, stepY;
    // λms
    protected int interval;
    // ǰǷʾ
    protected volatile boolean action;
    
	// 갴ʱô˱Ϊtrueʾƶ״̬
	private boolean isMove;
	// 갴ʱλ
	private int downX, downY;
    
    /**
     * 캯
     * 
     * @param parent
     * 			parent shell
     * @param w
     * 			ʾڿ
     * @param h
     * 			ʾڸ߶
     */
    public AbstractHinter(Shell parent, int w, int h) {
        this.parent = parent;
        display = parent.getDisplay();
        width = w;
        height = h;
        initX = initY = 0;
        stepX = stepY = 5;
        interval = 50;
        action = false;
        hintShell = new Shell(parent, SWT.ON_TOP | SWT.NO_TRIM);
        hintShell.setSize(width, height);
        hintShell.addMouseMoveListener(new ShellMouseMoveListener());
        hintShell.addMouseListener(new ShellMouseListener());
        hintShell.addPaintListener(new ShellPainterListener());
        initVaribles();
        createContent(hintShell);
    }
    
    /**
     * dispose¼
     * 
     * @param listener
     * 			DisposeListener
     */
    public void addDisposeListener(DisposeListener listener) {
        hintShell.addDisposeListener(listener);
    }
    
    /**
     * ɾdispose¼
     * 
     * @param listener
     * 			DisposeListener
     */
    public void removeDisposeListener(DisposeListener listener) {
        hintShell.removeDisposeListener(listener);
    }
    
    /**
     * ʾ
     */
    public void show() {
        if(checkAndSet()) {
	        if(showGril != null)
	            showGril.show(this);
	        else
	            hintShell.setVisible(true);      
        }
    }
    
    /**
     * ʾڣǲر
     */
    public void hide() {
        if(checkAndSet()) {
	        if(hideBoy != null)
	            hideBoy.hide(this);
	        else
	            hintShell.setVisible(false);
        }
    }    
    
    /**
     * ö־ǰѾtrueˣ򷵻false
     * 
     * @return ־óɹ򷵻true򷵻false
     */
    public synchronized boolean checkAndSet() {
        if(action) return false;
        action = true;
        return true;
    }
    
    /**
     * ö־ΪfalseԼЧ
     */
    public synchronized void releaseAction() {
        action = false;
    }
    
    /**
     * ʾڲͷŴԴ
     */
    public void dispose() {
        hide();
        hintShell.dispose();
    }
    
    protected abstract void initVaribles();
    
    /**
     * 沼
     * 
     * @param hintShell
     * 			ʾ
     * @return
     * 			Composite
     */
    protected abstract Composite createContent(Shell hintShell);
    
    /**
     * ʾϢʾϢɵһһṩʹ
     * 
     * @param model
     * 			ϢԴmodel
     */
    public abstract void setHint(Object model);
    
    /**
     * ʾϢʾϢͶأʹ
     * 
     * @param models
     * 			ϢԴmodel
     */
    public abstract void setHint(Object[] models);
    
    /**
     * @return Returns the backgroundImage.
     */
    public Image getBackgroundImage() {
        return backgroundImage;
    }
    
    /**
     * @param backgroundImage The backgroundImage to set.
     */
    public void setBackgroundImage(Image backgroundImage) {
        this.backgroundImage = backgroundImage;
    }
    
    /**
     * @return ʾڵǰԭ
     */
    public Point getLocation() {
        return hintShell.getLocation();
    }
    
    /**
     * ñɫ
     * 
     * @param color
     * 			Color
     */
    public void setBackgroundColor(Color color) {
        hintShell.setBackground(color);
    }
    
    /**
     * @param hideBoy The hideBoy to set.
     */
    public void setHideStyle(IHide hideBoy) {
        this.hideBoy = hideBoy;
    }
    
    /**
     * @param showGril The showGril to set.
     */
    public void setShowStyle(IShow showGril) {
        this.showGril = showGril;
    }
    
    /**
     * @return Returns the initX.
     */
    public int getInitX() {
        return initX;
    }
    
    /**
     * @param initX The initX to set.
     */
    public void setInitX(int initX) {
        this.initX = initX;
    }
    
    /**
     * @return Returns the initY.
     */
    public int getInitY() {
        return initY;
    }
    
    /**
     * @param initY The initY to set.
     */
    public void setInitY(int initY) {
        this.initY = initY;
    }
    
    /**
     * @return ʾShell
     */
    public Shell getShell() {
        return hintShell;
    }
    
    /**
     * @return Returns the height.
     */
    public int getHeight() {
        return height;
    }
    
    /**
     * @return Returns the width.
     */
    public int getWidth() {
        return width;
    }
    
    /**
     * @return Returns the interval.
     */
    public int getInterval() {
        return interval;
    }
    
    /**
     * @param interval The interval to set.
     */
    public void setInterval(int interval) {
        this.interval = interval;
    }
    
    /**
     * @return Returns the stepX.
     */
    public int getStepX() {
        return stepX;
    }
    
    /**
     * @param stepX The stepX to set.
     */
    public void setStepX(int stepX) {
        this.stepX = stepX;
    }
    
    /**
     * @return Returns the stepY.
     */
    public int getStepY() {
        return stepY;
    }
    
    /**
     * @param stepY The stepY to set.
     */
    public void setStepY(int stepY) {
        this.stepY = stepY;
    }
    
    /**
     * ôλ
     * 
     * @param p
     * 			λ
     */
    public void setLocation(Point p) {
        hintShell.setLocation(p);
    }
    
    /**
     * trueʾѾdisposed
     */
    public boolean isDisposed() {
        return hintShell.isDisposed();
    }
    
    /**
     * ôڿɼ 
     * 
     * @param b
     * 			trueʾɼ 
     */
    public void setVisible(boolean b) {
        hintShell.setVisible(b);
    }
    
    /**
     * @return trueʾǰɼ
     */
    public boolean isVisible() {
        return hintShell.isVisible();
    }
    
    /**
     * @return display
     */
    public Display getDisplay() {
        return parent.getDisplay();
    }
    
    /**
     * ôڴС
     * 
     * @param w
     * 		
     * @param h
     * 		
     */
    public void setSize(int w, int h) {
        hintShell.setSize(w, h);
    }

    /**
     * ôλ
     * 
     * @param x
     * 			x
     * @param y
     * 			y
     */
    public void setLocation(int x, int y) {
        hintShell.setLocation(x, y);
    }
    
    /**
     * @return Returns the parent.
     */
    public Shell getParent() {
        return parent;
    }
}
