/*
* Shutter - Friend List Component
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.widgets;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.swt.SWT;
import org.eclipse.swt.SWTException;
import org.eclipse.swt.dnd.DND;
import org.eclipse.swt.dnd.DragSource;
import org.eclipse.swt.dnd.DragSourceListener;
import org.eclipse.swt.dnd.DropTarget;
import org.eclipse.swt.dnd.DropTargetListener;
import org.eclipse.swt.dnd.TextTransfer;
import org.eclipse.swt.dnd.Transfer;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.ControlListener;
import org.eclipse.swt.events.DisposeEvent;
import org.eclipse.swt.events.DisposeListener;
import org.eclipse.swt.events.MouseAdapter;
import org.eclipse.swt.events.MouseEvent;
import org.eclipse.swt.events.MouseMoveListener;
import org.eclipse.swt.events.MouseTrackAdapter;
import org.eclipse.swt.events.PaintEvent;
import org.eclipse.swt.events.PaintListener;
import org.eclipse.swt.graphics.Color;
import org.eclipse.swt.graphics.GC;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Text;

import edu.tsinghua.swt.events.CoolButtonListener;
import edu.tsinghua.swt.internal.events.EditorFocusListener;
import edu.tsinghua.swt.internal.events.EditorKeyListener;
import edu.tsinghua.swt.internal.resources.Icons;


/**
 * <pre>
 * ShutterеĻԪءShutterLabelһʾͼƬֵԶ
 * һжЧĹܣLabelãҲButtoná
 * 
 * <b>Style:</b>
 * 		MySWT.HOVER, MySWT.IMAGE_HOVER, MySWT.FLAT, MySWT.TOGGLE, MySWT.NO_ZOOM
 *      SWT.LEFT, SWT.RIGHT, SWT.TOP, SWT.BOTTOM, SWT.CENTER
 * <b>Note:</b>
 * 		SWT.LEFT, SWT.RIGHT, SWT.TOP, SWT.BOTTOMֻܳһָSWT.CENTER
 *      ൱ָؼΪTab
 * </pre>
 *
 * @author 
 */
public class CoolButton extends Composite implements DisposeListener, PaintListener, ControlListener {	
    // ʾ߳
    public class Animate implements Runnable {
        private int frame;
        private Image[] frames;
        private volatile boolean stop;
        
        public void setFrames(Image[] images) {
            frame = 0;
            frames = images;
            stop = false;
        }        

        public void run() {
            try {                      
            	if(!stop) {
	                setImage(frames[frame]);
	                frame++;
	                if(frame >= frames.length)
	                    frame = 0;            		
            	}
                if(!stop)
                    getDisplay().timerExec(300, this);
            } catch (SWTException e) {         
                // ܻ׳SWTExceptionѾdisposeĻ
                //     Ҫ׽쳣Ȼܱ
            }
        }

		public void setStop(boolean stop) {
			this.stop = stop;
		}
    }
    
    // ˸ͼ߳
    private class Blink implements Runnable {
        private Image blinkImage;
        private boolean flag;
        private volatile boolean stop;

        public void run() {
            try {                      
            	if(!stop) {
		            if(flag)
		                setImage(blinkImage);
		            else
		                setImage(null);
		            flag = !flag;            		
            	}
	            if(!stop)
	                getDisplay().timerExec(500, this);
            } catch (SWTException e) {         
                // ܻ׳SWTExceptionѾdisposeĻ
                //     Ҫ׽쳣Ȼܱ
            }
        }
        
        public void setStop(boolean stop) {
        	this.stop = stop;
        }
        
		public void setBlinkImage(Image blinkImage) {
			this.blinkImage = blinkImage;
            this.flag = true;
            this.stop = false;
		}
    }
    
    // ͼ߳
    private class Bounce implements Runnable {
    	private volatile boolean stop;
        private int frame;
        private int[][] offset = new int[][] {
                {-1, 1}, {0, 0}, {1, 1}, {0, 0}
        };
        
        public void setBounceImage(Image bounceImage) {
            this.frame = 0;
            this.stop = false;
            setImage(bounceImage);
        }

        public void run() {
        	try {
	        	if(!stop) {
		            // ƫ
		            bX = offset[frame][0];
		            bY = offset[frame][1];
		            frame++;
		            if(frame >= offset.length)
		                frame = 0;
		            // ػ
		            redraw();        		
	        	}
	            if(!stop)
	                getDisplay().timerExec(300, this);        		
            } catch (SWTException e) {         
                // ܻ׳SWTExceptionѾdisposeĻ
                //     Ҫ׽쳣Ȼܱ
            }
        }

		public void setStop(boolean stop) {
			this.stop = stop;
		}
    }
    
	// ȱʡƶֻǼ򵥵ж굱ǰλǷͼֵϷ
	private class ShutterLabelMouseMoveListener implements MouseMoveListener {
		private Color old;
		public void mouseMove(MouseEvent e) {
			// ΪʲôҪıupأΪпûmouseյmousedown¼
			//     upfalseȴûյmouseup¼ǻԭup
			if(!isToggle()) up = true;
			
			boolean b = false, changed = false;
			// ǷͼϷ
			if(totalBound.contains(e.x, e.y)) b = true;
			// ֮ǰǷͼϷвͬchangedΪtrue
			if(imageEnter != b) {
				imageEnter = b;
				changed = true;
			}
			// changedΪtrueػ
			if(changed) {
				refreshForeground();
				redraw();
			}
		}
	}
    
    // ȱʡ
    private class ShutterLabelMouseTrackListener extends MouseTrackAdapter {        
        public void mouseEnter(MouseEvent e) {
            enter = true;
            if(totalBound.contains(e.x, e.y)) imageEnter = true;
            refreshForeground();
            redraw();
        }

        public void mouseExit(MouseEvent e) {
            enter = false;
            imageEnter = false;
            refreshForeground();
            redraw();
        }
    }
    
    // ȱʡ궯
    private class ShutterLabelMouseListener extends MouseAdapter {
        public void mouseDown(MouseEvent e) {
        	if(isToggle()) {
        		up = !up;
        		redraw();
        	} else {
	            up = false;
	            redraw();        		
        	}
        }
        
        public void mouseUp(MouseEvent e) {
        	if(!isToggle()) {
	            up = true;
	            redraw();        		
        	}
        }
    }
    
	// small and large image
	private Image image, imageBak;
	// image bound
	private Rectangle imageBound;
	// small image size and large image size
	private Rectangle smallBound, largeBound;
	// style, defined in MySWT
	private int style;
	// ǷʾСͼ
	private boolean showSmallImage;
	// Ƿ
	private boolean up;
	// Ƿؼ
	private boolean enter;
	// Ƿͼ
	private boolean imageEnter;
	// 
	private String text, textBak;
	// Ƿʾ
	private boolean showText;
	// ˮƽʹֱ϶
	private int horizontalSpacing, verticalSpacing; 
	// ֵĳ
	private int textOrientation;
	// ֱ༭
	private Text editor;
	// ShutterLabel¼
	private List listeners;
	// ؼΧʱʾɫ
	private Color mouseTrackColor;
	// ʾǷ˸ͼ
	private boolean doEffect, blinking, bouncing, animating;
	// һͼʱͼƫ
	private int bX, bY;
	// ͼ
	private Image bgImage;
	// ͼֵΧ
	private Rectangle totalBound;
	// ͻС
	private Rectangle clientArea;
	// ϵǰɫ
	private Color oldForeground;
	// Ч
	private Blink blinkRunnable;
	private Bounce bounceRunnable;
	private Animate animateRunnable;
	// ϶ԴĿ
	private DragSource dragSource;
	private DropTarget dropTarget;
	
    /**
     * @param parent parent
     * @param style style
     */
    public CoolButton(Composite parent, int style) {
		super(parent, SWT.NONE);
		Icons.getInstance().loadResources();
        init(style, null, Icons.getInstance().getImage(MySWT.DEFAULT_IMAGE));
    }
    
	/**
	 * @param parent composite
	 * @param style style
	 * @param text text string
	 */
	public CoolButton(Composite parent, int style, String text) {
		super(parent, SWT.NONE);
		Icons.getInstance().loadResources();
	    init(style, text, Icons.getInstance().getImage(MySWT.DEFAULT_IMAGE));
	}
	
	/**
	 * @param parent parent
	 * @param style style
	 * @param text text string
	 * @param smallImage small image
	 * @param largeImage large image
	 */
	public CoolButton(Composite parent, int style, String text, Image image) {
		super(parent, SWT.NONE);
		Icons.getInstance().loadResources();
		init(style, text, image);
	}

    /**
     * @param style
     * @param text
     * @param smallImage2
     * @param largeImage2
     */
    private void init(int style, String text, Image image) {
        // set layout
        this.setLayout(new FormLayout());
		// ʼimage
        this.image = this.imageBak = image;
        if(image != null)
            imageBound = image.getBounds();
        else 
        	imageBound = new Rectangle(0, 0, 0, 0);
		smallBound = new Rectangle(0, 0, 16, 16);
		largeBound = new Rectangle(0, 0, 32, 32);
		// style
		checkStyle(style);
		// ʼ
		up = true;
		enter = false;
		imageEnter = false;
		showSmallImage = true;
		doEffect = blinking = bouncing = animating = false;
		showText = true;
		horizontalSpacing = verticalSpacing = 1;
		this.text = this.textBak = text;
		listeners = new ArrayList();
		bX = bY = 0;
		totalBound = new Rectangle(1 + horizontalSpacing, 1 + verticalSpacing, 0, 0);
		refreshTotalBound();
		blinkRunnable = new Blink();
		bounceRunnable = new Bounce();
		animateRunnable = new Animate();
		// ʼ༭
		editor = new Text(this, SWT.BORDER | SWT.SINGLE);
		FormData fd = new FormData();
		fd.top = fd.left = new FormAttachment(0, 0);
		fd.bottom = fd.right = new FormAttachment(100, 0);
		editor.setLayoutData(fd);
		editor.setVisible(false);
		editor.addKeyListener(new EditorKeyListener(this, listeners));
		editor.addFocusListener(new EditorFocusListener(this, listeners));
		// Ӽ
		addDisposeListener(this);
		addPaintListener(this);
		addControlListener(this);
		super.addMouseListener(new ShutterLabelMouseListener());
		super.addMouseTrackListener(new ShutterLabelMouseTrackListener());
		super.addMouseMoveListener(new ShutterLabelMouseMoveListener());
    }
    
    // style
    private void checkStyle(int style) {
		// styleֵֻ
		this.style = style & (SWT.LEFT | SWT.RIGHT | SWT.BOTTOM | SWT.TOP | SWT.CENTER | MySWT.TOGGLE | MySWT.HOVER | MySWT.IMAGE_HOVER | MySWT.NO_ZOOM | MySWT.FLAT);
		// styleıλûУûȱʡright
	    textOrientation = this.style & (SWT.LEFT | SWT.RIGHT | SWT.BOTTOM | SWT.TOP);
	    if(textOrientation == 0) textOrientation = SWT.RIGHT;
    }
    
    /**
     * һlistener
     * @param listener
     */
    public void addShutterLabelListener(CoolButtonListener listener) {
        listeners.add(listener);
    }
    
    /**
     * Ƴһlistener
     * @param listener
     */
    public void removeShutterLabelListener(CoolButtonListener listener) {
        listeners.remove(listener);
    }
    
    /**
     * ʹ༭ʾԱڱ༭ı
     */
    public void editText() {
        editor.setVisible(true);
        editor.setFocus();
        editor.setText(text==null?"":text);
        editor.selectAll();
    }
    
    /**
     * Ƿʾ
     * @param show trueʾʾ
     */
    public void setShowText(boolean show) {
        if(showText == show) return;
        if(show) {
            showText = show;
            setText(textBak);
        } else {
            textBak = text;
            setText(null);
	        showText = show;
        }
    }
    
    /**
     * ؼΧʱʾɫ
     * @param color ؼΧʱʾɫ
     */
    public void setMouseTrackColor(Color color) {
        this.mouseTrackColor = color;
    }
    
    // Hover߽磬ƶʾı߽
    private void paintHoverBorder(GC gc, Rectangle r, boolean up) {
        if(!enter) return;
        Display disp = getDisplay();
        Color c1 = null;
        Color c2 = null;
        c1 = disp.getSystemColor(up?SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW:SWT.COLOR_WIDGET_BORDER);
        c2 = disp.getSystemColor(up?SWT.COLOR_WIDGET_BORDER:SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW);
        if(c1 != null && c2 != null)
            drawBevelRect(gc, r.x, r.y, r.width - 1, r.height - 1, c1, c2);
    }
    
    // Tabı߽
    private void paintTabBorder(GC gc, Rectangle r, boolean up) {
        Display disp = getDisplay();
        Color c1 = null;
        Color c2 = null;
        c1 = disp.getSystemColor(up?SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW:SWT.COLOR_WIDGET_DARK_SHADOW);
        c2 = disp.getSystemColor(up?SWT.COLOR_WIDGET_DARK_SHADOW:SWT.COLOR_WIDGET_HIGHLIGHT_SHADOW);
        if(c1 != null && c2 != null) 
            drawBevelRect(gc, r.x, r.y, r.width - 1, r.height - 1, c1, c2);
    }
    
    // һBevel
    private void drawBevelRect(GC gc, int x, int y, int w, int h, Color topleft, Color bottomright)
    {
        Color old = gc.getForeground();
        gc.setForeground(bottomright);
        gc.drawLine(x + w, y, x + w, y + h);
        gc.drawLine(x, y + h, x + w, y + h);
        gc.setForeground(topleft);
        gc.drawLine(x, y, (x + w) - 1, y);
        gc.drawLine(x, y, x, (y + h) - 1);
        gc.setForeground(old);
    }
    
	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.DisposeListener#widgetDisposed(org.eclipse.swt.events.DisposeEvent)
	 */
	public void widgetDisposed(DisposeEvent e) {
		// free resources
		Icons.getInstance().freeResources();
	}

    /* (non-Javadoc)
     * @see org.eclipse.swt.events.PaintListener#paintControl(org.eclipse.swt.events.PaintEvent)
     */
    public void paintControl(PaintEvent event) {
        // õͻС
        if(clientArea.width == 0 || clientArea.height == 0)
            return;
        
        // ÿȣȲض
        boolean shorten = false;
        String t = text;
        int availableWidth = clientArea.width - 2 * horizontalSpacing - 2;
        Point extent = getTotalSize();
        if(extent.x > availableWidth) 
            shorten = true;

        GC gc = event.gc;
        // ͼ
        if(bgImage != null) {
            Rectangle imageRect = bgImage.getBounds();
            gc.drawImage(bgImage, 0, 0, imageRect.width, imageRect.height, 1, 1, clientArea.width - 2, clientArea.height - 2);
        }
        // Ҫض֣õض̺
        if(shorten) 
            t = shortenText(gc, t, availableWidth);
        // ߽
        // ƽģ߽
        if(!isFlat() || (isToggle() && !up)) paintTabBorder(gc, clientArea, up);
        // Ҫhover border
        if(isHover() && (!isToggle() || isToggle() && up)) paintHoverBorder(gc, clientArea, up);
        // imageҲҪhover border滭
        if(imageEnter && isImageHover() && image != null) {        	
            Rectangle bound = null;
            if(isZoom())
            	bound = showSmallImage ? smallBound : largeBound;
            else
            	bound = imageBound;
            bound = new Rectangle(bound.x, bound.y, bound.width, bound.height);
            if(textOrientation == SWT.LEFT) {
                bound.x = clientArea.width - 1 - horizontalSpacing - bound.width;
                bound.y = 1 + verticalSpacing;
            } else if(textOrientation == SWT.RIGHT) {
                bound.x = 1 + horizontalSpacing;
                bound.y = 1 + verticalSpacing;
            } else if(textOrientation == SWT.BOTTOM) {
                bound.x = (clientArea.width - bound.width) / 2;
                bound.y = 1 + verticalSpacing;
            } else {
                bound.x = (clientArea.width - bound.width) / 2;
                bound.y = clientArea.height - 1 - verticalSpacing - bound.height;
            }
            // ĿҪͼһ
            bound.x--;
            bound.y--;
            bound.width +=2;
            bound.height +=2;
            // bounceĵ
            bound.x += bX;
            bound.y += bY;
            paintHoverBorder(gc, bound, up);
        }
        
        // ͼ꣬ȼͼλ
        Rectangle bound = null;
        if(isZoom())
        	bound = showSmallImage?smallBound:largeBound;
        else
        	bound = imageBound;   
        int x = 0, y = 0, endX = 0;
        // Ϊnullͼ꣬ﻭxֵΪ
        if(image != null) { 
	        if(textOrientation == SWT.RIGHT) {
	            x = 1 + horizontalSpacing;
	            y = 1 + verticalSpacing;                
	        } else if(textOrientation == SWT.LEFT) {
	            x = clientArea.width - 1 - horizontalSpacing - bound.width;
	            y = 1 + verticalSpacing;
	        } else if(textOrientation == SWT.BOTTOM) {
	            x = (clientArea.width - bound.width) / 2;
	            y = 1 + verticalSpacing;
	        } else {
	            x = (clientArea.width - bound.width) / 2;
	            y = clientArea.height - 1 - verticalSpacing - bound.height;
	        }        
            gc.drawImage(image, 0, 0, imageBound.width, imageBound.height, x + bX, y + bY, bound.width, bound.height);
            endX = x + bound.width;
            x = bound.width;
        }
        // 
        if(t != null) {
            int h = gc.getFontMetrics().getHeight();
            int w = gc.textExtent(t, SWT.DRAW_TRANSPARENT).x;
            if(isTab()) {
                if(textOrientation == SWT.LEFT || textOrientation == SWT.RIGHT) {
                    // жһǷḲͼƬǣͼƬԱ߻
                    x = (clientArea.width - w) / 2;
                    if(x < endX + 5)
                        gc.drawString(t, endX + 5, (clientArea.height - h) / 2, true);
                    else
                        gc.drawString(t, (clientArea.width - w) / 2, (clientArea.height - h) / 2, true);
                } else if(textOrientation == SWT.BOTTOM) {
                    if(image != null || doEffect)
                        gc.drawString(t, (clientArea.width - w) / 2, 1 + verticalSpacing + bound.height + 5, true);
                    else
                        gc.drawString(t, (clientArea.width - w) / 2, (clientArea.height - h) / 2, true);                        
                } else {
                    gc.drawString(t, (clientArea.width - w) / 2, 1 + verticalSpacing, true);
                }
            } else {
                if(doEffect) x = bound.width;
                if(textOrientation == SWT.LEFT) 
                    gc.drawString(t, clientArea.width - 1 - horizontalSpacing - x - 5 - w, (clientArea.height - h) / 2, true);
                else if(textOrientation == SWT.RIGHT)
                    gc.drawString(t, 1 + horizontalSpacing + x + 5, (clientArea.height - h) / 2, true);
                else if(textOrientation == SWT.BOTTOM) {
                    if(image != null || doEffect)
                        gc.drawString(t, (clientArea.width - w) / 2, 1 + verticalSpacing + bound.height + 5, true);
                    else
                        gc.drawString(t, (clientArea.width - w) / 2, (clientArea.height - h) / 2, true);
                } else
                    gc.drawString(t, (clientArea.width - w) / 2, 1 + verticalSpacing, true);
            }
        }
    }
    
    // ض̵ַм俪ʼϼ٣мʡԺţֱȺδ֪
    protected String shortenText(GC gc, String t, int width) {
        if(t == null)
            return null;
        int w = gc.textExtent("...").x;
        int l = t.length();
        int pivot = l / 2;
        int s = pivot;
        for(int e = pivot + 1; s >= 0 && e < l; e++) {
            String s1 = t.substring(0, s);
            String s2 = t.substring(e, l);
            int l1 = gc.textExtent(s1).x;
            int l2 = gc.textExtent(s2).x;
            if(l1 + w + l2 < width) {
                t = s1 + "..." + s2;
                break;
            }
            s--;
        }

        return t;
    }
    
    /**
     * @return Returns the style.
     */
    public int getStyle() {
        return style;
    }
    
    /**
     * ־еǰtab
     * @return trueһTab
     */
    public boolean isTab() {
        return (style & SWT.CENTER) != 0;
    }
    
    // жǷʽFlat
    private boolean isFlat() {
        return (style & MySWT.FLAT) != 0;
    }
    
    // жʽǷHover
    private boolean isHover() {
        return (style & MySWT.HOVER) != 0;
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.swt.widgets.Control#computeSize(int, int, boolean)
     */
    public Point computeSize(int wHint, int hHint, boolean changed) {
        Point e = getTotalSize();
        if(wHint == SWT.DEFAULT)
            e.x += 2 * horizontalSpacing + 2;
        else
            e.x = wHint;
        if(hHint == SWT.DEFAULT)
            e.y += 2 * verticalSpacing + 2;
        else
            e.y = hHint;
        return e;
    }
    
    // õimagetextܴС
    private Point getTotalSize() {
        Rectangle bound = null;
        if(isZoom())
        	bound = showSmallImage?smallBound:largeBound;
        else
        	bound = imageBound;  
        Point size = new Point(0, 0);
        if(image != null || doEffect) {
            size.x += bound.width;
            size.y += bound.height;
        }
        GC gc = new GC(this);
        if(text != null && text.length() > 0) {
            Point e = gc.textExtent(text, SWT.DRAW_TRANSPARENT);
            // Tab⴦ΪTabԶ
            if(isTab()) {
                if(textOrientation == SWT.LEFT || textOrientation == SWT.RIGHT) {
                    size.x = size.x * 2 + e.x + 10;
                    size.y = (image != null) ? Math.max(size.y, e.y) : bound.height;
                } else {
                    size.x = Math.max(e.x, size.x) + 10;               
                    size.y += (image != null) ? (e.y + 5) : bound.height;
                }
            } else if(textOrientation == SWT.LEFT || textOrientation == SWT.RIGHT) {
	            // 5صĿ϶
	            size.x += e.x + 10;
	            size.y = (image != null) ? Math.max(size.y, e.y) : bound.height;
            } else {
                // ߸5ؿ϶ٱȽ˭Ŀ
                size.x = Math.max(size.x, e.x + 10);
                size.y += e.y;
	            // ͼ겻Ϊգͼ֮϶
	            if(image != null || doEffect)
	                size.y += 5;
	            else
	                size.y = bound.height;
            }
        } else {
            if(textOrientation == SWT.LEFT || textOrientation == SWT.RIGHT)
                size.y = Math.max(size.y, gc.getFontMetrics().getHeight());
        }
        gc.dispose();
        return size;
    }
    
    /**
     * @return Returns the text.
     */
    public String getText() {
        return text;
    }
    
    /**
     * @param text The text to set.
     */
    public void setText(String text) {
        if(showText) {
            this.text = text;
            // imagetextΧ
            refreshTotalBound();
            // ػ
	        redraw();            
        } else
            textBak = text; 
    }
    
    /**
     * @return Returns the showSmallImage.
     */
    public boolean isShowSmallImage() {
        return showSmallImage;
    }
    
    /**
     * @param showSmallImage The showSmallImage to set.
     */
    public void setShowSmallImage(boolean showSmallImage) {
        this.showSmallImage = showSmallImage;
        refreshTotalBound();
        redraw();
    }
    
    /**
     * @return Returns the textOrientation.
     */
    public int getTextOrientation() {
        return textOrientation;
    }
    
    /**
     * @param textOrientation The textOrientation to set.
     */
    public void setTextOrientation(int textOrientation) {
        this.textOrientation = textOrientation;
        refreshTotalBound();
        redraw();
    }
    
    /**
     * @return Returns the image.
     */
    public Image getImage() {
        return image;
    }
    
    /**
     * @param image The image to set.
     */
    public void setImage(Image image) {
        this.image = image;
        if(image != null) 
        	this.imageBound = image.getBounds();
        
        // imagetextΧ
        refreshTotalBound();
        // ػ
        redraw();
    }
    
    /**
     * @return Returns the horizontalSpacing.
     */
    public int getHorizontalSpacing() {
        return horizontalSpacing;
    }
    
    /**
     * @param horizontalSpacing The horizontalSpacing to set.
     */
    public void setHorizontalSpacing(int horizontalSpacing) {
        this.horizontalSpacing = horizontalSpacing;
        this.totalBound.x = 1 + this.horizontalSpacing;
    }
    
    /**
     * @return Returns the verticalSpacing.
     */
    public int getVerticalSpacing() {
        return verticalSpacing;
    }
    
    /**
     * @param verticalSpacing The verticalSpacing to set.
     */
    public void setVerticalSpacing(int verticalSpacing) {
        this.verticalSpacing = verticalSpacing;
        this.totalBound.y = 1 + this.verticalSpacing;
    }
    
    /**
     * @return trueimageҲҪhover border
     */
    public boolean isImageHover() {
        return (style & MySWT.IMAGE_HOVER) != 0;
    }
    
    /**
     * ˸һͼ
     * @param blinkImage Ҫ˸ͼ
     */
    public void startBlinkImage(Image blinkImage) {
        if(doEffect || blinkImage == null) return;
        doEffect = blinking = true;
        this.getParent().layout();
        imageBak = image;
        blinkRunnable.setBlinkImage(blinkImage);
        getDisplay().timerExec(0, blinkRunnable);
    }
    
    /**
     * ֹͣ˸ͼ
     */
    public void stopBlinkImage() {
        if(!blinking) return;
        blinkRunnable.setStop(true);
        doEffect = blinking = false;        
        setImage(imageBak);
        this.getParent().layout();
    }
    
    /**
     * һͼ
     * @param bounceImage Ҫͼ
     */
    public void startBounceImage(Image bounceImage) {        
        if(doEffect || bounceImage == null) return;
        doEffect = bouncing = true;
        this.getParent().layout();
        imageBak = image;
        bounceRunnable.setBounceImage(bounceImage);
        getDisplay().timerExec(0, bounceRunnable);
    }
    
    /**
     * ֹͣͼ
     */
    public void stopBounceImage() {
        if(!bouncing) return;
        bounceRunnable.setStop(true);
        doEffect = bouncing = false;
        bX = bY = 0;
        setImage(imageBak);
        this.getParent().layout();
    }
    
    /**
     * ʼ
     * @param images ֡
     */
    public void startAnimate(Image[] images) {
        if(doEffect || images == null) return;
        doEffect = animating = true;
        this.getParent().layout();
        imageBak = image;
        animateRunnable.setFrames(images);
        getDisplay().timerExec(0, animateRunnable);
    }
    
    /**
     * ֹͣ
     */
    public void stopAnimate() {
        if(!animating) return;
        animateRunnable.setStop(true);
        doEffect = animating = false;
        setImage(imageBak);
        this.getParent().layout();
    }
    
    /**
     * ñͼ
     * @param image ͼ
     */
    public void setBackground(Image image) {
        if(this.bgImage == image) return;
        this.bgImage = image;
        redraw();
    }    
    
    // imagetextΧ
    private void refreshTotalBound() {
        Point extent = getTotalSize();
        totalBound.width = extent.x;
        totalBound.height = extent.y;
		clientArea = getClientArea();
		if(textOrientation == SWT.BOTTOM || textOrientation == SWT.TOP)
			totalBound.x = (clientArea.width - totalBound.width) / 2;
		else if(textOrientation == SWT.LEFT)
			totalBound.x = clientArea.width - totalBound.width;
		else
			totalBound.x = 2;
    }
    
    // Ƿͼ֮ǰɫ
    private void refreshForeground() {
		if(mouseTrackColor != null) {
			if(oldForeground == null) oldForeground = getForeground();
			if(imageEnter) 
				setForeground(mouseTrackColor);						
			else {
				setForeground(oldForeground);
				oldForeground = null;
			}
		}
    }
    
    /* (non-Javadoc)
     * @see org.eclipse.swt.widgets.Control#setEnabled(boolean)
     */
    public void setEnabled(boolean enabled) {
    	super.setEnabled(enabled);
    	if(enabled) {
    		if(oldForeground == null)
    			setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_BLACK));
    		else
    			setForeground(oldForeground);
    	} else
    		setForeground(Display.getCurrent().getSystemColor(SWT.COLOR_DARK_GRAY));
    }
    
    /**
     * ѡ״̬
     * @param selection
     */
    public void setSelection(boolean selection) {
    	if(this.up == selection) return;
    	this.up = selection;
    	redraw();
    }
    
    /**
     * صǰѡ״̬
     * @return true
     */
    public boolean getSelection() {
    	return up;
    }
    
    /**
     * жʽǷcheck button
     * @return
     */
    private boolean isToggle() {
    	return (style & MySWT.TOGGLE) != 0;
    }

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ControlListener#controlMoved(org.eclipse.swt.events.ControlEvent)
	 */
	public void controlMoved(ControlEvent e) {
	}

	/* (non-Javadoc)
	 * @see org.eclipse.swt.events.ControlListener#controlResized(org.eclipse.swt.events.ControlEvent)
	 */
	public void controlResized(ControlEvent e) {
		refreshTotalBound();
	}
	
	/**
	 * @return Returns the animating.
	 */
	public boolean isAnimating() {
		return animating;
	}
	
	/**
	 * @return Returns the blinking.
	 */
	public boolean isBlinking() {
		return blinking;
	}
	
	/**
	 * @return Returns the bouncing.
	 */
	public boolean isBouncing() {
		return bouncing;
	}
	
	/**
	 * @return Returns the showText.
	 */
	public boolean isShowText() {
		return showText;
	}
	
    // ϷĿ
	private DropTarget createDropTarget() {
		DropTarget dropTarget = new DropTarget(this, DND.DROP_MOVE);
		dropTarget.setTransfer(new Transfer[] { TextTransfer.getInstance() });
		return dropTarget;
	}	

	// ϷԴ
	private DragSource createDragSource() {
		DragSource dragSource = new DragSource(this, DND.DROP_MOVE);
		dragSource.setTransfer(new Transfer[] { TextTransfer.getInstance() });
		return dragSource;
	}
	
	/**
	 * ϷԴ
	 * @param listener
	 */
	public void addDragSourceListener(DragSourceListener listener) {
		if(dragSource == null)
			dragSource = createDragSource();
		dragSource.addDragListener(listener);
	}
	
	/**
	 * ɾϷԴ
	 * @param listener
	 */
	public void removeDragSourceListener(DragSourceListener listener) {
		dragSource.removeDragListener(listener);
	}
	
	/**
	 * ϷĿ
	 * @param listener
	 */
	public void addDropTargetListener(DropTargetListener listener) {
		if(dropTarget == null)
			dropTarget = createDropTarget();
		dropTarget.addDropListener(listener);
	}
	
	/**
	 * ɾϷĿ
	 * @param listener
	 */
	public void removeDropTargetListener(DropTargetListener listener) {
		dropTarget.removeDropListener(listener);
	}
	
	/**
	 * ͼǷ
	 * @return
	 */
	private boolean isZoom() {
		return (style & MySWT.NO_ZOOM) == 0;
	}
}
