/*
 *  2003-9-25
 */
package edu.tsinghua.swt.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Dialog;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;

/**
 * @author 
 */
public class InputDialog extends Dialog {
    private Shell dialog;

    private Display display;

    private String input;

    /**
     * @param shell
     */
    public InputDialog(Shell shell) {
        this(shell, 0);
    }

    /**
     * @param shell
     * @param style
     */
    public InputDialog(Shell shell, int style) {
        super(shell, style);
        dialog = new Shell(shell, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
        display = shell.getDisplay();
        initLayout();
    }

    /**
     * ʼڲ
     */
    public void initLayout() {
        GridLayout layout = new GridLayout();
        layout.numColumns = 2;
        layout.marginHeight = layout.marginWidth = 0;
        dialog.setLayout(layout);

        final Text text = new Text(dialog, SWT.SINGLE | SWT.BORDER);
        GridData gd = new GridData(GridData.FILL_HORIZONTAL);
        gd.horizontalSpan = 2;
        gd.widthHint = 200;
        text.setLayoutData(gd);
        text.addKeyListener(new KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if (e.keyCode == SWT.CR) {
                    input = text.getText();
                    dialog.close();
                }
            }
        });

        Button cmdOK = new Button(dialog, SWT.PUSH | SWT.DEFAULT);
        cmdOK.setText("OK");
        gd = new GridData(GridData.FILL_HORIZONTAL);
        gd.widthHint = 80;
        cmdOK.setLayoutData(gd);
        cmdOK.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                input = text.getText();
                dialog.close();
            }
        });

        Button cmdCancel = new Button(dialog, SWT.PUSH);
        cmdCancel.setText("Cancel");
        gd = new GridData(GridData.FILL_HORIZONTAL);
        gd.widthHint = 80;
        cmdCancel.setLayoutData(gd);
        cmdCancel.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                input = null;
                dialog.close();
            }
        });
    }

    /**
     * @return
     * 
     * ʾԻ
     */
    public String open() {
        dialog.setText(getText());
        dialog.pack();
        Rectangle dialogRect = dialog.getBounds();
        Rectangle displayRect = display.getBounds();
        dialog.setLocation((displayRect.width - dialogRect.width) / 2,
                (displayRect.height - dialogRect.height) / 2);
        dialog.open();
        while (!dialog.isDisposed()) {
            if (!display.readAndDispatch())
                display.sleep();
        }

        return input;
    }
}