/*
* LumaQQ - Java QQ Client
*
* Copyright (C) 2004 luma <stubma@163.com>
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA 02111-1307 USA
*/
package edu.tsinghua.swt.widgets;

import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ControlAdapter;
import org.eclipse.swt.events.ControlEvent;
import org.eclipse.swt.events.KeyAdapter;
import org.eclipse.swt.events.KeyEvent;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Text;

/**
 * <pre>
 * Spin boxͷťʾĸʽΪ
 * SWT.LEFT
 * SWT.RIGHT
 * SWT.TOP
 * SWT.BOTTOM
 * ʽֻܴһ
 * </pre>
 * 
 * @author 
 */
public class Spin extends Composite {
    // ֵСֵ
    private int min, max;
    // ǰֵ
    private int value;
    
    // ʾı
    private Text textValue;
    // ť
    private Button btnIncrease, btnDecrease;
    
    /**
     * 캯
     * 
     * @param parent
     * 			
     * @param style
     * 			ʽ
     */
    public Spin(Composite parent, int style) {
        super(parent, SWT.NONE);
        // ʽ
        int s = checkStyle(style);
        // ʼ
        initMembers();
        // ʼ
        initLayout(s);
        // ʼlistener
        initListener(s);
    }

    /**
     * ʼlistener
     * 
     * @param style
     * 			ʽ
     */
    private void initListener(final int style) {
        // ؼresize
        addControlListener(new ControlAdapter() {
            public void controlResized(ControlEvent e) {
                GridData gdInc = (GridData)btnIncrease.getLayoutData();
                GridData gdDec = (GridData)btnDecrease.getLayoutData();
                if((style & SWT.LEFT) != 0 || (style & SWT.RIGHT) != 0) {
                    int h = getClientArea().height / 2;
                    gdInc.heightHint = gdDec.heightHint = h;                    
                } else {
                    int w = getClientArea().width / 2;
                    gdInc.widthHint = gdDec.widthHint = w;
                }
                layout();
            }
        });
        
        // ť
        btnIncrease.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                if(value < max) {
                    value++;
                    textValue.setText(String.valueOf(value));
                }
            }
        });
        btnDecrease.addSelectionListener(new SelectionAdapter() {
            public void widgetSelected(SelectionEvent e) {
                if(value > min) {
                    value--;
                    textValue.setText(String.valueOf(value));
                }
            }
        });
       
        // ı򰴼¼
        textValue.addKeyListener(new KeyAdapter() {
            public void keyPressed(KeyEvent e) {
                if(Character.isDigit(e.character) || Character.isISOControl(e.character))
                    return;
                else if(e.character == '-' && textValue.getSelection().x == 0)                    
                    return;
                else
                    e.doit = false;
            }
        });
        // ıı¼
        textValue.addModifyListener(new ModifyListener() {
            public void modifyText(ModifyEvent arg0) {
                String newText = textValue.getText().trim();
                String valueString = String.valueOf(value);
                if(!valueString.equals(newText)) {
                    try {
                        int newValue = Integer.parseInt(newText);
                        if(newValue <= max && newValue >= min)
                            value = newValue;
                        else
                            textValue.setText(valueString);
                    } catch (NumberFormatException e) {
                        textValue.setText(valueString);
                    }
                }
            }
        });
    }

    /**
     * ʼԱ
     */
    private void initMembers() {
        // СֵʼֵȡСƽֵ
        min = Integer.MIN_VALUE;
        max = Integer.MAX_VALUE;
        value = (min + max) >> 1;
    }

    /**
     * ʼ沼
     * @param s
     */
    private void initLayout(int s) {
        if((s & SWT.BOTTOM) != 0)
            initBottomStyle();
        else if((s & SWT.LEFT) != 0)
            initLeftStyle();
        else if((s & SWT.TOP) != 0)
            initTopStyle();
        else
            initRightStyle();
    }

    /**
     * ʼӰť
     */
    private void initBottomStyle() {
        // layout
        GridLayout layout = new GridLayout();
        layout.horizontalSpacing = layout.verticalSpacing = layout.marginHeight = layout.marginWidth = 0;
        layout.numColumns = 2;
        setLayout(layout);
        // ı
        textValue = new Text(this, SWT.SINGLE | SWT.BORDER);
        textValue.setText(String.valueOf(value));
        GridData gd = new GridData(GridData.FILL_BOTH);
        gd.horizontalSpan = 2;
        textValue.setLayoutData(gd);
        // ٰť
        btnDecrease = new Button(this, SWT.ARROW | SWT.LEFT);
        gd = new GridData();
        btnDecrease.setLayoutData(gd);
        // Ӱť
        btnIncrease = new Button(this, SWT.ARROW | SWT.RIGHT);
        gd = new GridData();
        btnIncrease.setLayoutData(gd);
    }

    /**
     * ʼť
     */
    private void initTopStyle() {
        // layout
        GridLayout layout = new GridLayout();
        layout.horizontalSpacing = layout.verticalSpacing = layout.marginHeight = layout.marginWidth = 0;
        layout.numColumns = 2;
        setLayout(layout);
        // ٰť
        btnDecrease = new Button(this, SWT.ARROW | SWT.LEFT);
        GridData gd = new GridData();
        btnDecrease.setLayoutData(gd);
        // Ӱť
        btnIncrease = new Button(this, SWT.ARROW | SWT.RIGHT);
        gd = new GridData();
        btnIncrease.setLayoutData(gd);
        // ı
        textValue = new Text(this, SWT.SINGLE | SWT.BORDER);
        textValue.setText(String.valueOf(value));
        gd = new GridData(GridData.FILL_BOTH);
        gd.horizontalSpan = 2;
        textValue.setLayoutData(gd);
    }

    /**
     * ʼӰťұߵ
     */
    private void initRightStyle() {
        // layout
        GridLayout layout = new GridLayout();
        layout.horizontalSpacing = layout.verticalSpacing = layout.marginHeight = layout.marginWidth = 0;
        layout.numColumns = 2;
        setLayout(layout);
        // ı
        textValue = new Text(this, SWT.SINGLE | SWT.BORDER);
        textValue.setText(String.valueOf(value));
        GridData gd = new GridData(GridData.FILL_BOTH);
        gd.verticalSpan = 2;
        textValue.setLayoutData(gd);
        // Ӱť
        btnIncrease = new Button(this, SWT.ARROW | SWT.UP);
        gd = new GridData();
        gd.widthHint = 20;
        btnIncrease.setLayoutData(gd);
        // ٰť
        btnDecrease = new Button(this, SWT.ARROW | SWT.DOWN);
        gd = new GridData();
        gd.widthHint = 20;
        btnDecrease.setLayoutData(gd);
    }

    /**
     * ʼťߵ
     */
    private void initLeftStyle() {
        // layout
        GridLayout layout = new GridLayout();
        layout.horizontalSpacing = layout.verticalSpacing = layout.marginHeight = layout.marginWidth = 0;
        layout.numColumns = 2;
        setLayout(layout);
        // Ӱť
        btnIncrease = new Button(this, SWT.ARROW | SWT.UP);
        GridData gd = new GridData();
        gd.widthHint = 20;
        btnIncrease.setLayoutData(gd);
        // ı
        textValue = new Text(this, SWT.SINGLE | SWT.BORDER);
        textValue.setText(String.valueOf(value));
        gd = new GridData(GridData.FILL_BOTH);
        gd.verticalSpan = 2;
        textValue.setLayoutData(gd);
        // ٰť
        btnDecrease = new Button(this, SWT.ARROW | SWT.DOWN);
        gd = new GridData();
        gd.widthHint = 20;
        btnDecrease.setLayoutData(gd);
    }

    /**
     * ʽϷԣȥϷʽ
     * 
     * @param style
     * 			ʽ
     * @return Ϸʽ
     */
    private int checkStyle(int style) {
        style &= (SWT.LEFT | SWT.RIGHT | SWT.TOP | SWT.BOTTOM);
        if(style == 0)
            style |= SWT.RIGHT;
        return style;
    }
    
    /**
     * @return Returns the max.
     */
    public int getMax() {
        return max;
    }
    
    /**
     * @param max The max to set.
     */
    public void setMax(int max) {
        if(max < min) return;
        this.max = max;
        checkUpper();
    }
    
    /**
     * @return Returns the min.
     */
    public int getMin() {
        return min;
    }
    
    /**
     * @param min The min to set.
     */
    public void setMin(int min) {
        if(min > max) return;
        this.min = min;
        checkLower();
    }
    
    /**
     * @return Returns the value.
     */
    public int getValue() {
        return value;
    }
    
    /**
     * @param value The value to set.
     */
    public void setValue(int value) {
        this.value = value;
        checkUpper();
        checkLower();
    }
    
    /**
     * Ƿ񳬳ǣvalueΪmax
     */
    private void checkUpper() {
        if(value > max) {
            value = max;
            textValue.setText(String.valueOf(value));
        }
    }
    
    /**
     * Ƿ񳬳ǣvalueΪmin
     */
    private void checkLower() {
        if(value < min) {
            value = min;
            textValue.setText(String.valueOf(value));
        }
    }
}
